#include "es.h"
#include "syscalls.h"

#include <ctype.h>
#include <stdio.h>

#define PROMPT	"APPLE Commande ? "

int	main()
{
	code_erreur	erreur;
	char		ligne[80];
	char		commande[80], souscom[80], type[80];
	int		i, volume, mode, canal, piste, secteur, pos, n;
	char		nom[80], nom1[80], nom2[80], *buf, c;

	erreur = SYS_InitialisationSysteme();
	if (erreur!=OK) {
		Perreur(erreur);
		return 1;
	}
	for (;;) {
		fputs(PROMPT,stdout);
		gets(ligne);
		for (i=0; i<strlen(ligne); i++) ligne[i] = toupper(ligne[i]);
		sscanf(ligne,"%s",commande);
/* INIT [volume_number] */
		if (!strcmp(commande,"INIT")) {
			if (sscanf(ligne,"%s %d",commande,&volume)==1)
				volume = 0;
			erreur = SYS_Init(volume);
			if (erreur!=OK) Perreur(erreur);
			continue;
		}
/* CATALOG */
		if (!strcmp(commande,"CATALOG")) {
			erreur = SYS_Catalog();
			if (erreur!=OK) Perreur(erreur);
			continue;
		}
/* OPEN <nom> <mode> <canal> */
		if (!strcmp(commande,"OPEN")) {
			if (sscanf(ligne,"%s %s %d %d",commande,nom,&mode,
			    &canal)!=4)
				fprintf(stderr,"Commande mal formee\n");
			else {
				erreur = SYS_Open(nom,mode,canal);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* CLOSE <canal> */
		if (!strcmp(commande,"CLOSE")) {
			if (sscanf(ligne,"%s %d",commande,&canal)!=2)
				fprintf(stderr,"Commande mal formee\n");
			else {
				erreur = SYS_Close(canal);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* POSITION <canal> <position> <mode> */
		if (!strcmp(commande,"POSITION")) {
			if (sscanf(ligne,"%s %d %d %d",commande,&canal,&pos,
				&mode)!=4)
				fprintf(stderr,"Commande mal formee\n");
			else {
				erreur = SYS_Position(canal,pos,mode);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* RENAME <source> <destination> */
		if (!strcmp(commande,"RENAME")) {
			if (sscanf(ligne,"%s %s %s",commande,nom1,nom2)!=3) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Rename(nom1,nom2);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* LOCK <fic> */
		if (!strcmp(commande,"LOCK")) {
			if (sscanf(ligne,"%s %s",commande,nom1)!=2) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Lock(nom1);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* UNLOCK <fic> */
		if (!strcmp(commande,"UNLOCK")) {
			if (sscanf(ligne,"%s %s",commande,nom1)!=2) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Unlock(nom1);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* CREATE <fic> */
		if (!strcmp(commande,"CREATE")) {
			if (sscanf(ligne,"%s %s",commande,nom1)!=2) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Create(nom1);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* DELETE <fic> */
		if (!strcmp(commande,"DELETE")) {
			if (sscanf(ligne,"%s %s",commande,nom1)!=2) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Delete(nom1);
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* WRITE <canal> <donnees> */
		if (!strcmp(commande,"WRITE")) {
			nom1[0] = '\0';
			if (sscanf(ligne,"%s %d %s",commande,&canal,nom1)!=3) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Write(canal,(octet *)nom1,strlen(nom1));
				if (erreur!=OK) PErreur(erreur);
			}
			continue;
		}
/* READ <canal> <n> */
		if (!strcmp(commande,"READ")) {
			if (sscanf(ligne,"%s %d %d",commande,&canal,&n)!=3) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				if (buf!=NULL) free(buf);
				buf = (char *)malloc(n+1);
				if (buf==NULL) {
					fprintf(stderr,"Pbm alloc buffer\n");
					continue;
				}
				erreur = SYS_Read(canal,&n,(octet *)buf);
				if (erreur!=OK) PErreur(erreur);
				buf[n] = '\0';
				printf("%s:",buf);
				for (i=0; i<n; i++) printf("%d ",buf[i]);
				printf("\n");
			}
			continue;
		}
/* TYPE <fichier> <canal> */
		if (!strcmp(commande,"TYPE")) {
			nom1[0] = '\0';
			if (sscanf(ligne,"%s %s %d",commande,nom1,&canal)!=3) {
				fprintf(stderr,"Commande mal formee\n");
			}
			else {
				erreur = SYS_Open(nom1,LECTURE,canal);
				if (erreur!=OK) {
					PErreur(erreur);
				}
				else {
					n = 1;
					do {
						erreur = SYS_Read(canal,&n,
							(octet *)&c);
						if (erreur==OK)
							printf("%c",c);
					} while (erreur==OK);
					printf("\n");
					if (erreur!=FIN_DE_FICHIER) {
						PErreur(erreur);
					}
					erreur = SYS_Close(canal);
					if (erreur!=OK) PErreur(erreur);
				}
			}
			continue;
		}
/* SHOW [ OPEN | SECTOR <track> <sector> <type> ] */
		if (!strcmp(commande,"SHOW")) {
			switch (sscanf(ligne,"%s %s %x %x %s",commande,souscom,
				&piste,&secteur,type)) {
			case 2:
				if (!strcmp(souscom,"OPEN")) {
					erreur = SYS_ShowOpen();
					if (erreur!=OK) PErreur(erreur);
				}
				else
					fprintf(stderr,"Commande mal formee\n");
				break;
			case 4:
				erreur = SYS_ShowSector(piste,secteur,"N");
				if (erreur!=OK) PErreur(erreur);
				break;
			case 5:
				erreur = SYS_ShowSector(piste,secteur,type);
				if (erreur!=OK) PErreur(erreur);
				break;
			}
			continue;
		}
/* HELP */
		if (!strcmp(commande,"HELP")) {
			fprintf(stderr,"\n\n\
Commandes valides:\n\
------------------\n\
INIT [#]			: Initialisation du disk avec numero de volume\n				  eventuel\n\
CATALOG				: Liste des fichiers presents sur le disk\n\
OPEN <nom> <mode> <canal>	: Ouverture du fichier <nom> sur le canal\n\
				  de numero <canal> avec le mode <mode>\n\
				  Les modes possibles sont:\n\
				  1: Lecture seule\n\
				  2: Ecriture seule\n\
				  3: Lecture/Ecriture\n\
CLOSE <canal>			: Fermeture du fichier de numero <canal>\n\
SHOW OPEN			: Liste des fichiers ouverts\n\
SHOW SECTOR <t> <s> [<type>]	: Liste le contenu d'un secteur <t><s> avec\n\
				  le type VTOC, CATALOG ou NORMAL\n\
POSITION <canal> <pos> <mode>	: Positionne le numero d'octet courant a\n\
				  <position> pour le canal de numero <canal>\n\
				  avec le mode 0 (depuis le debut) ou le mode\n\
				  1 (depuis la fin) ou le mode 2 (depuis\n\
				  le positionnement courant)\n\
RENAME <fic1> <fic2>		: Renomme le fichier <fic1> en <fic2>\n\
LOCK <fic>			: Protege le fichier <fic> contre\n\
				  l'effacement\n\
UNLOCK <fic>			: Enleve la protection du fichier <fic>\n\
				  contre l'effacement\n\
DELETE <fic>			: Supprime le fichier <fic>\n\
CREATE <fic>			: Cree le fichier de nom <fic>\n\
WRITE <canal> <donnees>		: Ecrit les donnees dans le fichier <canal>\n\
READ <canal> <n>		: Lit <n> octets dans le fichier <canal>\n\
TYPE <fichier> <canal>		: Affiche le contenu du fichier <fichier>\n\
				  sur l'ecran en utilisant le <canal>\n\
QUIT				: Quitter l'emulateur\n\n\n");
			continue;
		}
/* QUIT */
		if (!strcmp(commande,"QUIT")) break;
		fprintf(stderr,"???: Commande inconnue: %s\n",ligne);
	}
	erreur = SYS_TerminaisonSysteme();
	if (erreur!=OK) {
		Perreur(erreur);
		return 1;
	}
	return 0;
}
