#include "es.h"
#include <stdio.h>	/* Pour Perreur */

static char	*es_e_messages[] = {
	"Ok",			/* Ne devrait jamais etre imprime!!! */
	"Probleme de moteur",
	"Ecriture de secteur impossible",
	"Lecture de secteur impossible",
	"Moteur eteint, operation impossible",
	"Positionnement du bras impossible"
};

#include <fcntl.h>
#include <unistd.h>

static	int	disk, flag;

code_erreur DemarreMoteur()
{
	if (flag==0) {
		disk = open("disk",O_RDWR|O_CREAT,0777);
		if (disk==-1) return E_MOTEUR;
		flag = 1;
	}
	return OK;
}

code_erreur EteintMoteur()
{
	if (flag==1) {
		close(disk);
		flag = 0;
	}
	return OK;
}

code_erreur EcritSecteur(TS adresse,octet	*donnees)
{
	if (flag==0) return E_MOTEUR_ETEINT;
	if (lseek(disk,METS_BRAS(adresse),SEEK_SET)==-1)
		return E_BRAS;
	if (write(disk,donnees,N_OCTETS)!=N_OCTETS) return E_ECR_SECTEUR;
	return OK;
}

code_erreur LitSecteur(TS adresse,octet *donnees)
{
int	compte;

	if (flag==0) return E_MOTEUR_ETEINT;
	if (lseek(disk,METS_BRAS(adresse),SEEK_SET)==-1)
		return E_BRAS;
	compte = read(disk,donnees,N_OCTETS);
	if (compte!=N_OCTETS && compte !=0) return E_LEC_SECTEUR;
	if (compte==0) bzero(donnees,N_OCTETS);
	return OK;
}

void	Perreur(code_erreur erreur)
{
	if (erreur>OK && erreur<MAX_MESSAGES_ES)
		fprintf(stderr,"%s\n",es_e_messages[erreur]);
	else
		fprintf(stderr,"Erreur (E/S) Inconnue %x\n",erreur);
}
