#ifndef APPELS_SYSTEMES_H
#define APPELS_SYSTEMES_H

#include "systypes.h"
#include "sysstructs.h"

typedef union		Tampon {
	Catalog		catalog;
	TSL		tsl;
	Secteur		secteur;
} Tampon;

typedef struct Tampon_Courant {
	octet		etat;
#define	TAMPON_LIBRE		0
#define TAMPON_PROPRE		1
#define TAMPON_SALE		2
	TS		adresse;
	Tampon		tampon;
} Tampon_Courant;
#define	MAX_TAMPONS	10
#define HASH(ts)	(((ts).piste+(ts).secteur)%MAX_TAMPONS)

typedef struct Localisation {
	octet		occupation;
#define LOCALISATION_LIBRE	0
#define PAS_LOCALISE		LOCALISATION_LIBRE
#define PAS_OCCUPE		PAS_LOCALISE
#define LOCALISATION_OCCUPEE	1
#define DESCRIPTEUR_OCCUPE	LOCALISATION_OCCUPEE
#define PLUS_DE_LOCALISATION	2
	TS		catalog;
	octet		entree;
	Fichier		fichier;	/* Copie memoire du catalogue */
} Localisation;

typedef struct Descripteur {
	int		mode;
	Localisation	localisation;	/* Localisation dans le catalog */
	TS		tsl;		/* TSL courante */
#define PAS_DE_TSL(d)	(FIN_CHAINAGE((d).tsl))
	TS		secteur;	/* Secteur de donnees courant */
#define PAS_DE_SECTEUR(d)	(FIN_CHAINAGE((d).secteur))
	mot		deplacement;	/* Par rapport au debut du fichier */
	short		nbre_ts;	/* Combien de TS pour ce fichier */
	mot		ts_courante;	/* Offset dans la TSL courante */
} Descripteur;
#define DESC_OCC(d)	((d).localisation.occupation==LOCALISATION_OCCUPEE)
#define MAX_DESCRIPTEURS	10
#define BON_CANAL(c)		((c)>0 && (c)<=MAX_DESCRIPTEURS)

code_erreur	SYS_Init(octet);
code_erreur	SYS_Open(char *,int,int);
#define		LECTURE		1
#define		ECRITURE	2
code_erreur	SYS_Close(int);
code_erreur	SYS_InitialisationSysteme();
code_erreur	SYS_TerminaisonSysteme();
code_erreur	SYS_Catalog();
code_erreur	SYS_ShowOpen();
code_erreur	SYS_ShowSector(num_piste,num_secteur,char *);
code_erreur	SYS_Position(int,int,int);
#define		POSITION_DEBUT		0
#define		POSITION_FIN		1
#define		POSITION_COURANTE	2
code_erreur	SYS_Write(int,octet *,mot);
code_erreur	SYS_Read(int,int *,octet *);
code_erreur	SYS_Rename(char *,char *);
code_erreur	SYS_Lock(char *);
code_erreur	SYS_Unlock(char *);
code_erreur	SYS_Delete(char *);
code_erreur	SYS_Create(char *);
void		PErreur(code_erreur);

#define MAUVAIS_DESCRIPTEUR	0x0100
#define MODE_INCONNU		0x0200
#define FICHIER_INEXISTANT	0x0300
#define DEJA_OUVERT		0x0400
#define PARAMETRES_FAUX		0x0500
#define ECRITURE_INTERDITE	0x0600
#define	MAUVAISE_POSITION	0x0700
#define	CATALOG_PLEIN		0x0800
#define FIN_DE_FICHIER		0x0900
#define FICHIER_EXISTANT	0x0a00
#define MAUVAIS_PARAMETRES	0x0b00
#define FICHIER_OUVERT		0x0c00
#define FICHIER_PROTEGE		0x0d00
#define MAUVAIS_NOM		0x0e00
#define FICHIER_PAS_EN_ECRITURE	0x0f00
#define DISQUE_PLEIN		0x1000
#define FICHIER_PAS_EN_LECTURE	0x1100
#define MAX_MESSAGES		17

#endif APPELS_SYSTEMES_H
